import java.awt.Shape;
//import java.awt.geom.GeneralPath; wird hier nicht bentig, kann gelscht werden.
//import java.awt.geom.Rectangle2D; wird hier nicht bentig, kann gelscht werden.
//import java.awt.geom.AffineTransform; wird hier nicht bentig, kann gelscht werden.


/**
 * Eine abstrakte Klasse Moebel.
 * 
 * @author Claus Albowski
 * @version kommentierte Version vom September'10
 */
public abstract class Moebel
{
   /**
    * Die Attribute muessen auch den erbenden Klassen zur Verfuegung stehen.
    * Unter Verletzung des Prinzips der Kapselung von Daten muss daher die
    * Sichtbarkeit auf protected gesetzt werden.
    */
    protected int xPosition;
    protected int yPosition;
    protected int orientierung;
    protected String farbe;
    protected boolean istSichtbar;
    protected int breite;
    protected int tiefe;

    /**
     * Ein Kostruktor ist nicht sinnvoll, da es keine undifferenzierten Objekte vom Typ Moebel gibt.
     */
    
    /**
     * Berechnet das zu zeichnende Shape anhand der gegebenen Daten.
     * Diese Methode soll hier nicht implementiert werden, muss aber bekannt sein.
     */
    protected abstract Shape gibAktuelleFigur() ; 
    
    /**
     * >>>>>>>>>>> Die nachfolgenden Methoden sind unveraendert aus den erbenden Klassen hierher
     * >>>>>>>>>>> uebernommen worden.
     */
    
    /**
     * Mache dieses Objekt sichtbar. Wenn es bereits sichtbar ist, tue nichts.
     */
    public void zeige() {
        if (!istSichtbar) {
            istSichtbar = true;
            zeichne();
        }
    }
    
    /**
     * Mache dieses Objekt unsichtbar. Wenn es bereits unsichtbar ist, tue nichts.
     */
    public void verberge() {
        loesche(); // "tue nichts" wird in loesche() abgefangen.
        istSichtbar = false;
    }
    
    /**
     * Drehe auf den angegebenen Winkel
     */
    public void dreheAuf(int neuerWinkel) {
        loesche();
        orientierung = neuerWinkel;
        zeichne();
    }
    
    /**
     * Bewege dieses Objekt horizontal um 'entfernung' Bildschirmpunkte.
     */
    public void bewegeHorizontal(int entfernung) {
        loesche();
        xPosition += entfernung;
        zeichne();
    }
    
    /**
     * Bewege dieses objekt vertikal um 'entfernung' Bildschirmpunkte.
     */
    public void bewegeVertikal(int entfernung) {
        loesche();
        yPosition += entfernung;
        zeichne();
    }
    
    
    /**
     * Aendere die Farbe dieses Objektes in 'neueFarbe'.
     * Gueltige Angaben sind "rot", "gelb", "blau", "gruen",
     * "lila" und "schwarz".
     */
    public void aendereFarbe(String neueFarbe) {
        loesche();
        farbe = neueFarbe;
        zeichne();
    }
    
    /**
     * Zeichne dieses Objekt mit seinen aktuellen Werten auf den Bildschirm.
     */
    private void zeichne() {
        if (istSichtbar) {
            Shape figur = gibAktuelleFigur();
            Leinwand leinwand = Leinwand.gibLeinwand();
            leinwand.zeichne (
              this,           // leinwand kennt das Objekt
              farbe,          // definiert seine Zeichenfarbe
              figur);         // definiert seinen grafischen Aspekt
            leinwand.warte(10);
        }
    }
    
    /**
     * Loesche dieses Objekt vom Bildschirm.
     */
    private void loesche() {
        if (istSichtbar){
            Leinwand leinwand = Leinwand.gibLeinwand();
            leinwand.entferne(this);
        }
    }
}
